import os
import bpy
import sys
import typing
import inspect
import pkgutil
import importlib
from pathlib import Path

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)

from Paneles.Colletions_layers import *
from Paneles.Custom_properties import *
from Operadores.Operation_key import *
from Paneles.Varios import *
from Paneles.Characters_app import *

from Paneles.Rig_Creator import *
from extra import *
from Operadores.Rig_Creator_Operation.RIg_Constraint_G import *

from Paneles.Paneles_Constraint.Constraint_Bone import *
from Paneles.Paneles_Constraint.Constraint_Object import *
from Paneles.Paneles_Constraint.Constraint_Op import *
from Paneles.Seletion_Bone_Operation import *
from Paneles.Enum_properties.Enum_Panel import *

from Paneles.Selections_bones.select_bone import *

classes = [
    #menu 
    Enum_Follow_L,
    Enum_Follow_R,
    call_enum_operator,
    
    
    
    Collections_menu,
    Properties_menu,
    
    
    VIEWColletions_layers,
    VIEWCustomProperties,
    Fisicas,
    CustomPanelCol,
    CustomPanelprop,
    General_operator,
    Fisicas_PropertyGroup,
    S_General_PropertyGroup,
    
    Characters_Add,
    Characters_exist_group,
    object_PropertyGroup,
    Optimizar_Rig,
    
    #panel
    OP_Select_Bones,
    OP_Input_Bones,
    Props_panel_Armature,
    Props_panel_bone,
    Panel_rig_creator_props,
    Collections_layers_Rig_Creator,
    Collections_layers,
    VIEWMateriales_glithc,
    Auto_Root,
    bone_context_active,
    
    
    
    
    call_menu_col,
    call_menu_prop_armature,
    call_menu_prop_bone,
    
    Rig_Creator,
    Rig_Creator_PropertyGroup,
    Rig_Creator_OP,
    Rig_Creator_Menu,
    wmRig_Creator,
    wmAdd_Bone_Def,
    Call_Rig_Menu,
    Call_Rig_Menu_GEN,

    
    #constraints
    Rig_Creator_Constraint,
    save_constraint_group,
    Const_Advanced_Options,
    View_3D_Rig_Creator_Constraint,
    add_Advanced,
    CONST_UL_List,
    OBJECT_OT_toggle_edit,
    
    #Sub_Paneles
    P_Armature_Reset,
    P_Generador_Def_Fk_y_Fingers,
    P_Generador_IK,
    P_Generador_FK,
    P_Generador_Bones,
    P_Generador_Auto_Bones,
    
    #call paneles
    call_paneles,
    
    #list
    OBJECT_CONST_PropertyGroup,
    BONE_CONST_PropertyGroup,
]

class_To_Cosntraint=[
    #Bone_constraint
    BONE_CONST_UL_List,
    Constraint_list,
    BONE_PT_constraints,
    BONE_OP_constraints,
    Copy_Constraint_To_Active,
    add_bone_const_motion_tracking,
    add_bone_const_transform,
    add_bone_const_tracking,
    add_bone_const_relationship,
    add_bone_const_Custom,
    add_bone_const_operator,
    Constraint_Influence,
    
    #modificadores
    DATA_PT_modifiers,
    
    #Object_constraint
    Copy_Constraint_To_Active_OBJ,
    OBJECT_CONST_UL_List,
    OBJECT_PT_constraints,
    OBJECT_Constraint_list,
    OBJECT_OP_constraints,
    CONSTRAINT_OT_add_target,
    CONSTRAINT_OT_remove_target,
    CONSTRAINT_OT_normalize_target_weights,
    CONSTRAINT_OT_disable_keep_transform,
    
    #Object Panels
    OBJECT_PT_bChildOfConstraint,
    OBJECT_PT_bTrackToConstraint,
    OBJECT_PT_bFollowPathConstraint,
    OBJECT_PT_bRotLimitConstraint,
    OBJECT_PT_bLocLimitConstraint,
    OBJECT_PT_bSizeLimitConstraint,
    OBJECT_PT_bRotateLikeConstraint,
    OBJECT_PT_bLocateLikeConstraint,
    OBJECT_PT_bSizeLikeConstraint,
    OBJECT_PT_bSameVolumeConstraint,
    OBJECT_PT_bTransLikeConstraint,
    OBJECT_PT_bActionConstraint,
    OBJECT_PT_bActionConstraint_target,
    OBJECT_PT_bActionConstraint_action,
    OBJECT_PT_bLockTrackConstraint,
    OBJECT_PT_bDistLimitConstraint,
    OBJECT_PT_bStretchToConstraint,
    OBJECT_PT_bMinMaxConstraint,
    OBJECT_PT_bClampToConstraint,
    OBJECT_PT_bTransformConstraint,
    OBJECT_PT_bTransformConstraint_source,
    OBJECT_PT_bTransformConstraint_destination,
    OBJECT_PT_bShrinkwrapConstraint,
    OBJECT_PT_bDampTrackConstraint,
    OBJECT_PT_bPivotConstraint,
    OBJECT_PT_bFollowTrackConstraint,
    OBJECT_PT_bCameraSolverConstraint,
    OBJECT_PT_bObjectSolverConstraint,
    OBJECT_PT_bTransformCacheConstraint,
    OBJECT_PT_bTransformCacheConstraint_time,
    OBJECT_PT_bTransformCacheConstraint_procedural,
    OBJECT_PT_bTransformCacheConstraint_velocity,
    OBJECT_PT_bTransformCacheConstraint_layers,
    OBJECT_PT_bArmatureConstraint,
    OBJECT_PT_bArmatureConstraint_bones,
    
    # Const Bone panels
    BONE_PT_bChildOfConstraint,
    BONE_PT_bTrackToConstraint,
    BONE_PT_bKinematicConstraint,
    BONE_PT_bFollowPathConstraint,
    BONE_PT_bRotLimitConstraint,
    BONE_PT_bLocLimitConstraint,
    BONE_PT_bSizeLimitConstraint,
    BONE_PT_bRotateLikeConstraint,
    BONE_PT_bLocateLikeConstraint,
    BONE_PT_bSizeLikeConstraint,
    BONE_PT_bSameVolumeConstraint,
    BONE_PT_bTransLikeConstraint,
    BONE_PT_bActionConstraint,
    BONE_PT_bActionConstraint_target,
    BONE_PT_bActionConstraint_action,
    BONE_PT_bLockTrackConstraint,
    BONE_PT_bDistLimitConstraint,
    BONE_PT_bStretchToConstraint,
    BONE_PT_bMinMaxConstraint,
    BONE_PT_bClampToConstraint,
    BONE_PT_bTransformConstraint,
    BONE_PT_bTransformConstraint_from,
    BONE_PT_bTransformConstraint_to,
    BONE_PT_bShrinkwrapConstraint,
    BONE_PT_bDampTrackConstraint,
    BONE_PT_bSplineIKConstraint,
    BONE_PT_bSplineIKConstraint_fitting,
    BONE_PT_bSplineIKConstraint_chain_scaling,
    BONE_PT_bPivotConstraint,
    BONE_PT_bFollowTrackConstraint,
    BONE_PT_bCameraSolverConstraint,
    BONE_PT_bObjectSolverConstraint,
    BONE_PT_bTransformCacheConstraint,
    BONE_PT_bTransformCacheConstraint_time,
    BONE_PT_bTransformCacheConstraint_procedural,
    BONE_PT_bTransformCacheConstraint_velocity,
    BONE_PT_bTransformCacheConstraint_layers,
    BONE_PT_bPythonConstraint,
    BONE_PT_bArmatureConstraint,
    BONE_PT_bArmatureConstraint_bones,
]


def prop_name_from_constraint_type(constraint_type):
    return f"has_{constraint_type.lower()}"


def reg():
    
    
    bpy.types.Scene.H_Fisicas_PropertyGroup = bpy.props.PointerProperty(type=Fisicas_PropertyGroup)
    bpy.types.Scene.S_General_PropertyGroup = bpy.props.PointerProperty(type=S_General_PropertyGroup)
    
    #rig Creator Properties
    bpy.types.Scene.Rig_Creator_PropertyGroup = bpy.props.PointerProperty(type=Rig_Creator_PropertyGroup)
    
  
    bpy.types.Scene.Characters_exist = bpy.props.CollectionProperty(type=Characters_exist_group)
    bpy.types.Scene.Characters_exist_index = bpy.props.IntProperty()
    
    bpy.types.Object.A_object_PropertyGroup = bpy.props.PointerProperty(type=object_PropertyGroup)

    bpy.types.VIEW3D_MT_armature_add.append(Add_Menu_Rig_Creator)
    bpy.types.TOPBAR_MT_edit_armature_add.append(Add_bone)
    
    bpy.types.Scene.save_constraint = bpy.props.CollectionProperty(type=save_constraint_group)
    bpy.types.Scene.save_constraint_index = bpy.props.IntProperty()
    
    
    bpy.types.BONE_PT_display_custom_shape.append(sna_add_to_bone_pt_display_custom_shape)
    
    #constraint
    bpy.types.VIEW3D_HT_tool_header.append(Add_const_advanced_Options)
    
    #object 
    bpy.types.Object.Object_Constraint_list = bpy.props.CollectionProperty(type=OBJECT_CONST_PropertyGroup)
    bpy.types.Object.Object_Constraint_list_index = bpy.props.IntProperty()
      
    #bone
    bpy.types.PoseBone.Bone_Constraint_list = bpy.props.CollectionProperty(type=BONE_CONST_PropertyGroup)
    bpy.types.PoseBone.Bone_Constraint_list_index = bpy.props.IntProperty()
    
    regselect_bones()
    regenum()
    extregister()
def unreg():
    del bpy.types.Scene.H_Fisicas_PropertyGroup
    del bpy.types.Scene.S_General_PropertyGroup

    del bpy.types.Scene.Characters_exist
    del bpy.types.Scene.Characters_exist_index
    del bpy.types.Object.A_object_PropertyGroup
    
    #rig Creator Properties
    del bpy.types.Scene.Rig_Creator_PropertyGroup
    del bpy.types.Scene.save_constraint
    del bpy.types.Scene.save_constraint_index
    
    bpy.types.BONE_PT_display_custom_shape.remove(sna_add_to_bone_pt_display_custom_shape)
    
    bpy.types.VIEW3D_MT_armature_add.remove(Add_Menu_Rig_Creator)
    bpy.types.TOPBAR_MT_edit_armature_add.remove(Add_bone)
    
    #constraint
    bpy.types.VIEW3D_HT_tool_header.remove(Add_const_advanced_Options)
    #Object constraint
    del bpy.types.Object.Object_Constraint_list
    del bpy.types.Object.Object_Constraint_list_index
    #bone constraint
    del bpy.types.PoseBone.Bone_Constraint_list
    del bpy.types.PoseBone.Bone_Constraint_list_index
    
    unregselect_bones()
    unregenum()
    extunregister()
      
    
    
