import bpy

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)   

from Creador_Bones import * 

def Generador_Bone():
    Armature = bpy.context.active_object
    bpy.ops.object.mode_set(mode='EDIT')
    bpy.context.object.data.use_mirror_x = False


    selected_bones = [bone for bone in bpy.context.selected_editable_bones]
    selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]

    num_selected_bones = len(selected_bones)
    
    active_scene = bpy.context.scene
    Rig_props = active_scene.Rig_Creator_PropertyGroup
    
    look_bone=Rig_props.look_bone
    add_orientation=Rig_props.add_orientation
    viewport_D_tipo=Rig_props.viewport_D_tipo
    use_Parent_b=Rig_props.use_Parent_b
    use_Strech_to_b=Rig_props.use_Strech_to_b
    use_viewport_d=Rig_props.use_viewport_d
    use_mas_1=Rig_props.use_mas_1
    Base_name_b=Rig_props.Base_name_b
    
    print(Rig_props.look_bone)
    #si estoy en Edit Bone
    if Armature and Armature.type == 'ARMATURE':


        ADD_BONES = []
        BONES_NAME = Base_name_b

        if use_mas_1 == True:
            Add_Bones(BONES_NAME, selected_bones_Name[0], num_selected_bones+1, ADD_BONES)

        else:
            Add_Bones(BONES_NAME, selected_bones_Name[0], num_selected_bones, ADD_BONES)


        if add_orientation == 'GLOBAL':
            if ADD_BONES:

            
                #X_Look
                X_Look = 0
                if look_bone == {'X'}:
                    X_Look = 1
                if look_bone == {'-X'}:
                    X_Look = -1

                #Y_Look  
                Y_Look = 0
                if look_bone == {'Y'}:
                    Y_Look = 1
                if look_bone == {'-Y'}:
                    Y_Look = -1

                #Z_Look 
                Z_Look = 0
                if look_bone == {'Z'}:
                    Z_Look = 1
                if look_bone == {'-Z'}:
                    Z_Look = -1

                if look_bone == None:
                    Z_Look = 1


                #Posicionar
                for i in range(num_selected_bones):
                    Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                     [selected_bones[i].head.x + X_Look, 
                                      selected_bones[i].head.y + Y_Look, 
                                      selected_bones[i].head.z + Z_Look], 
                                     0, 
                                     selected_bones[i].length / 2, 
                                     tengo_length = True)

                if use_mas_1 == True:
                    Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                         [selected_bones[-1].tail.x + X_Look, 
                                          selected_bones[-1].tail.y + Y_Look, 
                                          selected_bones[-1].tail.z + Z_Look], 
                                         0, 
                                         selected_bones[-1].length, 
                                         tengo_length = True)
        else:
            if ADD_BONES:

            
                #X_Look
                if look_bone == {'X'}:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + selected_bones[i].x_axis.normalized(), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + selected_bones[i].x_axis.normalized(), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)

                if look_bone == {'-X'}:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + (selected_bones[i].x_axis.normalized() * -1), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + (selected_bones[i].x_axis.normalized()  * -1), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)

                #Y_Look  
                if look_bone == {'Y'}:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + selected_bones[i].y_axis.normalized(), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + selected_bones[i].y_axis.normalized(), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)

                if look_bone == {'-Y'}:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + (selected_bones[i].y_axis.normalized() * -1), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + (selected_bones[i].y_axis.normalized()  * -1), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)


                #Z_Look 
                if look_bone == {'Z'}:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + selected_bones[i].z_axis.normalized(), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + selected_bones[i].z_axis.normalized(), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)

                if look_bone == {'-Z'}:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + (selected_bones[i].z_axis.normalized() * -1), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + (selected_bones[i].z_axis.normalized()  * -1), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)


                if look_bone == None:

                    for i in range(num_selected_bones):
                        Posicionar_Bones(ADD_BONES[i], selected_bones[i].head, 
                                         selected_bones[i].head + selected_bones[i].z_axis.normalized(), 
                                         0, 
                                         selected_bones[i].length, 
                                         tengo_length = True)

                    if use_mas_1 == True:

                        Posicionar_Bones(ADD_BONES[-1], selected_bones[-1].tail, 
                                             selected_bones[-1].tail + selected_bones[i].z_axis.normalized(), 
                                             0, 
                                             selected_bones[-1].length, 
                                             tengo_length = True)

        if use_viewport_d == True:
            for bone in ADD_BONES:
                bone.color.palette = 'THEME09'

        if use_Parent_b == True:
            for i in range(num_selected_bones):
                selected_bones[i].use_connect = False
                selected_bones[i].parent = ADD_BONES[i]

        for i in range(len(ADD_BONES)):
            ADD_BONES[i].use_deform = False


        Name_select_Bone = []
        Name_ADD_BONES = []
        
        def Append_name(Bone, donde):
            for b in Bone:
                donde.append(b.name)

        Append_name(selected_bones, Name_select_Bone)
        Append_name(ADD_BONES, Name_ADD_BONES)

        bpy.context.object.data.use_mirror_x = True


        bpy.ops.object.mode_set(mode='POSE')

        Pose_selected_bones = []
        POSE_ADD_BONES = []
        
        Bone_Bucar_Pose(Name_select_Bone, Pose_selected_bones)
        Bone_Bucar_Pose(Name_ADD_BONES, POSE_ADD_BONES)

        if POSE_ADD_BONES:
            for i in range(len(POSE_ADD_BONES)):

                if use_viewport_d == True:
                    
                    Cual_C_Obj = {
                        'SINGLE_ARROW': 0,
                        'CIRCLE': 1, 
                        'CUBE': 2,
                        'SPHERE': 3}
                    
                    
                    POSE_ADD_BONES[i].custom_shape = bpy.data.objects[f"Materiales_RIG_CREATOR.{Cual_C_Obj[viewport_D_tipo]}"]
                    POSE_ADD_BONES[i].custom_shape_scale_xyz /= 2

            if use_Strech_to_b == True:
                if use_mas_1 == True:
                    for i in range(num_selected_bones):
                        constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                        constraint.target = Armature
                        constraint.subtarget = POSE_ADD_BONES[i+1].name

        










