import bpy

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)   

from Creador_Bones import * 

def Generador_FK():
    Armature = bpy.context.active_object
    bpy.ops.object.mode_set(mode='EDIT')

    selected_bones = [bone for bone in bpy.context.selected_editable_bones]
    selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
    
    num_selected_bones = len(selected_bones)
    
    active_scene = bpy.context.scene
    Rig_props = active_scene.Rig_Creator_PropertyGroup
    
    use_view_object=Rig_props.use_view_object
    use_copy_transforms_FK=Rig_props.use_copy_transforms_FK
    Base_name_FK_S=Rig_props.Base_name_FK_S
    
    FK = Base_name_FK_S

    #si estoy en Edit Bone
    if Armature and Armature.type == 'ARMATURE':

        Fk_Controles = []

        if selected_bones:
            
            #FK Controles:
            Add_Bones(FK, selected_bones_Name[0], num_selected_bones, Fk_Controles)

            for i in range(num_selected_bones):
                Posicionar_Bones(Fk_Controles[i], selected_bones[i].head, 
                                 selected_bones[i].tail, selected_bones[i].roll, 
                                 selected_bones[i].length, tengo_length = False)

            if Fk_Controles:
                for i in range(num_selected_bones):
                    Fk_Controles[i].use_deform = False

            if Fk_Controles:
                for i in range(num_selected_bones -1):
                    Fk_Controles[i + 1].parent = Fk_Controles[i]
                    Fk_Controles[i + 1].use_connect = True
                    
        Name_select_Bone = []
        Name_Fk_Controles = []
        
        def Append_name(Bone, donde):
            for b in Bone:
                donde.append(b.name)

        Append_name(selected_bones, Name_select_Bone)
        Append_name(Fk_Controles, Name_Fk_Controles)


        bpy.ops.object.mode_set(mode='POSE')

        Pose_selected_bones = []
        Pose_Fk_Controles = []
        
        Bone_Bucar_Pose(Name_select_Bone, Pose_selected_bones)
        Bone_Bucar_Pose(Name_Fk_Controles, Pose_Fk_Controles)

        if Pose_selected_bones and Pose_Fk_Controles:

            if use_copy_transforms_FK == True:

                for i in range(num_selected_bones):

                            constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Fk_Controles[i].name


            if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.1"]:

                for i in range(num_selected_bones):

                    if use_view_object == True:

                        Pose_Fk_Controles[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.1"]
                        Pose_Fk_Controles[i].custom_shape_translation[1] = Pose_Fk_Controles[i].length / 2
                        Pose_Fk_Controles[i].color.palette = 'THEME03'
