# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)
from Swith import *

#Rig_Creator
bl_info = {
    "name" : "Rig_Creator",
    "author" : "Edward Ureña",
    "description" : "Rig Creator",
    "blender" : (4, 0, 0),
    "version" : (1, 2, 6),
    "location" : "",
    "warning" : "",
    "category" : "Animation"
}

#homstromp
#bl_info = {
#    "name" : "Hornstromp_Rig",
#    "author" : "Edward Ureña",
#    "description" : "Hornstromp",
#    "blender" : (4, 0, 0),
#    "version" : (6, 0, 8),
#    "location" : "",
#    "warning" : "",
#    "category" : "Animation"
#}


from . import auto_load

auto_load.init()


from .Clas import *
import bpy
from bpy.types import NodeTree, Node, PropertyGroup, NodeSocket
from bpy.props import FloatProperty, StringProperty, EnumProperty, CollectionProperty


from Paneles.Custom_properties import *
from Operadores.Operation_key import *
existe = []


def register():

    for cls in classes:
        bpy.utils.register_class(cls)
     
    for cls in class_To_Cosntraint:
        bpy.utils.register_class(cls)
      
    reg()
    reg_key()

    #auto_load.register()


def unregister():


    for cls in classes:
        bpy.utils.unregister_class(cls)
        
    for cls in class_To_Cosntraint:
        bpy.utils.unregister_class(cls)
        
        
    unreg()
    unreg_key()

   #auto_load.unregister()

if __name__ == "__main__":
    register()