
import bpy 
import time
import sys
import os

current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

def draw_base_list(
    row,
    list,
    type,
    text_grups,
    text_index,
    grups,
    index,
    operator,
    op_type=[
        "ADD","REMOVE",
        "MOVE_UP","MOVE_DOWN"
        ],
    use_menu = False,
    menu = ""
    ):
    
    
    
    row.template_list(
        list, 
        "", 
        type, text_grups, 
        type, text_index,
        rows=4 if grups else 1,)
    
    col = row.column(align=False)
    
    col_1 = col.column(align=True)
    col_1.operator(operator, text="", icon="ADD").type = op_type[0]
    col_= col_1.column(align=True)
    col_.enabled = len(grups) > 0
    col_.operator(operator, text="", icon="REMOVE").type = op_type[1]
    
    if grups: 
        col_2 = col.column(align=True)
        col_2 .operator(operator, text="", icon="TRIA_UP").type = op_type[2]
        col_2 .operator(operator, text="", icon="TRIA_DOWN").type = op_type[3]
    
        if use_menu:
            col_3 = col.column(align=True)
            col_3.menu(menu, text="", icon="DOWNARROW_HLT") 



            
    