import bpy

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)   

from Creador_Bones import * 
def Generador_IK():
    Armature = bpy.context.active_object
    bpy.ops.object.mode_set(mode='EDIT')

    active_scene = bpy.context.scene

    Rig_props = active_scene.Rig_Creator_PropertyGroup
    
    use_strech=Rig_props.use_strech
    use_pole_target=Rig_props.use_pole_target
    use_track_to=Rig_props.use_track_to
    use_copy_transforms_IK=Rig_props.use_copy_transforms_IK
    Angle_IK=Rig_props.Angle_IK
    Base_name_IK=Rig_props.Base_name_IK
    
    
    
    selected_bones = [bone for bone in bpy.context.selected_editable_bones]
    selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]

    num_selected_bones = len(selected_bones)

    IK = Base_name_IK
    IK_COntrole = "COLTROLES_" + IK


    
    #si estoy en Edit Bone
    if Armature and Armature.type == 'ARMATURE':

        IK_Bone = []
        Ik_Controles = []

        Nump = 0

        if use_pole_target == True:
            Nump = 4
        else:
            Nump = 3

        if selected_bones:

            #IK
            if num_selected_bones < 3:
                Numero_de_bones = num_selected_bones + 1
                Add_Bones(IK, selected_bones_Name[0], Numero_de_bones, IK_Bone)

                for i in range(num_selected_bones):
                    Posicionar_Bones(IK_Bone[i], selected_bones[i].head, 
                                     selected_bones[i].tail, selected_bones[i].roll, 
                                     selected_bones[i].length, tengo_length = False)

                if Numero_de_bones > 1:
                    Posicionar_Bones_tail(IK_Bone[-1], selected_bones[-1].head, 
                                        selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 2, 
                                        tengo_length = True)
                else:
                    Posicionar_Bones_tail(IK_Bone[-1], selected_bones[0].head, 
                                        selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 2, 
                                        tengo_length = True)
            else:

                Add_Bones(IK, selected_bones_Name[0], num_selected_bones, IK_Bone)

                for i in range(num_selected_bones):
                    Posicionar_Bones(IK_Bone[i], selected_bones[i].head, 
                                     selected_bones[i].tail, selected_bones[i].roll, 
                                     selected_bones[i].length, tengo_length = False)

        if selected_bones:

            #Ik_Controles
            Numero_de_bones = num_selected_bones + 1
            Add_Bones(IK_COntrole, selected_bones_Name[0], Nump, Ik_Controles)

            for i in range(2):
                Posicionar_Bones(Ik_Controles[i], selected_bones[0].head, 
                                 selected_bones[-1].tail, selected_bones[0].roll, 
                                 selected_bones[0].length / 2 , tengo_length = True)

            if num_selected_bones < 3:

                if Numero_de_bones > 1:
                    Posicionar_Bones_tail(Ik_Controles[2], selected_bones[-1].head, 
                                        selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 3, 
                                        tengo_length = True)
                else:
                    Posicionar_Bones_tail(Ik_Controles[2], selected_bones[0].head, 
                                        selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 3, 
                                        tengo_length = True)

            else:

                Posicionar_Bones(Ik_Controles[2], selected_bones[-1].head, 
                                 selected_bones[-1].tail, selected_bones[-1].roll, 
                                 selected_bones[-1].length / 2 , tengo_length = True)

            if use_pole_target == True:

                if Ik_Controles[3]:

                    Ik_Controles[3].head = IK_Bone[-2].head

                    Pocion_Normal = IK_Bone[-2].z_axis.normalized()
                    Pocion_Normal_1 = IK_Bone[-3].z_axis.normalized()
                    Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                    Ik_Controles[3].tail = IK_Bone[-2].head + (Normales * -1)
                    Ik_Controles[3].length = 2
                    new_head = (Ik_Controles[3].head + Ik_Controles[3].tail) / 2
                    Ik_Controles[3].head = new_head

                    Ik_Controles[3].length = Ik_Controles[0].length

            for i in range(Nump):
                Ik_Controles[i].use_deform = False

        if IK_Bone:

            if num_selected_bones < 3:

                for i in range(Numero_de_bones):
                    IK_Bone[i].use_deform = False

                for i in range(num_selected_bones):
                    IK_Bone[i + 1].parent = IK_Bone[i]
                    IK_Bone[i + 1].use_connect = True

                IK_Bone[-1].use_connect = False
                IK_Bone[-1].parent = None

            else:

                for i in range(num_selected_bones):
                    IK_Bone[i].use_deform = False

                for i in range(num_selected_bones - 1):
                    IK_Bone[i + 1].parent = IK_Bone[i]
                    IK_Bone[i + 1].use_connect = True

                IK_Bone[-1].use_connect = False
                IK_Bone[-1].parent = None

            if IK_Bone and Ik_Controles:

                IK_Bone[0].parent = Ik_Controles[0]
                IK_Bone[-1].parent = Ik_Controles[2]

                if use_pole_target == True:

                    Ik_Controles[3].parent = Ik_Controles[1]


        Name_select_Bone = []
        Name_IK_Bone = []
        Name_Ik_Controles = []
        
        def Append_name(Bone, donde):
            for b in Bone:
                donde.append(b.name)

        Append_name(selected_bones, Name_select_Bone)
        Append_name(IK_Bone, Name_IK_Bone)
        Append_name(Ik_Controles, Name_Ik_Controles)
            
        bpy.ops.object.mode_set(mode='POSE')

        Pose_selected_bones = []
        Pose_IK_Bone = []
        pose_Ik_Controles = []
        
        Bone_Bucar_Pose(Name_select_Bone, Pose_selected_bones)
        Bone_Bucar_Pose(Name_IK_Bone, Pose_IK_Bone)
        Bone_Bucar_Pose(Name_Ik_Controles, pose_Ik_Controles)

        if Pose_selected_bones:
        
           if Pose_IK_Bone[-2]:

               for i in range(num_selected_bones):
                    bpy.data.objects[Armature.name].pose.bones[Pose_IK_Bone[i].name].ik_stretch = 0.1

               constraint = Pose_IK_Bone[-2].constraints.new(type='IK')
               constraint.target = Armature
               constraint.subtarget = Pose_IK_Bone[-1].name

               if num_selected_bones < 3:
                    constraint.chain_count = num_selected_bones
               else:
                    constraint.chain_count = num_selected_bones -1

               if use_strech == True:
                   constraint.use_stretch = True
               else:
                   constraint.use_stretch = False

               if use_pole_target == True:

                    if constraint.target:
                         constraint.pole_target = Armature
                         constraint.pole_subtarget = pose_Ik_Controles[3].name
                         constraint.pole_angle = Angle_IK




        if pose_Ik_Controles:

            if use_copy_transforms_IK == True:
            
                if Pose_selected_bones and Pose_IK_Bone:

                    for i in range(num_selected_bones):

                        constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                        constraint.target = Armature
                        constraint.subtarget = Pose_IK_Bone[i].name


            constraint = pose_Ik_Controles[1].constraints.new(type='COPY_TRANSFORMS')
            constraint.target = Armature
            constraint.subtarget = pose_Ik_Controles[0].name

            if use_track_to == True:

                constraint = pose_Ik_Controles[0].constraints.new(type='DAMPED_TRACK')
                constraint.target = Armature
                constraint.subtarget = Pose_IK_Bone[-1].name

            if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.2"]:

                Armature_contex = bpy.data.objects[Armature.name].pose.bones
                Armature_contex[Pose_IK_Bone[-1].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                Armature_contex[Pose_IK_Bone[-1].name].custom_shape_translation[1] = (Pose_IK_Bone[-1].length) / 2
                Armature_contex[Pose_IK_Bone[-1].name].custom_shape_scale_xyz = [1, 1, 1]
                Armature_contex[Pose_IK_Bone[-1].name].custom_shape_scale_xyz /= 2

                Armature_contex[Pose_IK_Bone[-1].name].color.palette = 'THEME01'


                Armature_contex[pose_Ik_Controles[0].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                Armature_contex[pose_Ik_Controles[0].name].custom_shape_translation[1] = Pose_selected_bones[0].length
                Armature_contex[pose_Ik_Controles[0].name].custom_shape_scale_xyz = [1, 0, 1]
                Armature_contex[pose_Ik_Controles[0].name].color.palette = 'THEME01'


                if use_pole_target == True:

                    Armature_contex[pose_Ik_Controles[3].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                    Armature_contex[pose_Ik_Controles[3].name].custom_shape_scale_xyz /= 2
                    Armature_contex[pose_Ik_Controles[3].name].color.palette = 'THEME04'












    



